### Hierarchy

- DOMWidgetModel
  - ProxyModel
    - PlaceProxyModel

## Index

### Constructors

- constructor

### Properties

- _buffered_state_diff
- attributes
- changed
- cid
- collection
- comm
- comm_live
- id
- idAttribute
- model_id
- msg_buffer
- msg_buffer_callbacks
- pending_msgs
- state_change
- state_lock
- url
- urlRoot
- validationError
- views
- widget_manager
- serializers

### Methods

- _handle_comm_closed
- _handle_comm_msg
- _handle_status
- bind
- callbacks
- change
- changedAttributes
- clear
- clone
- close
- defaults
- destroy
- escape
- fetch
- get
- get_state
- has
- hasChanged
- initialize
- invert
- isNew
- isValid
- keys
- listenTo
- listenToOnce
- off
- omit
- on
- on_some_change
- once
- pairs
- parse
- pick
- previous
- previousAttributes
- save
- save_changes
- send
- send_sync_message
- set
- set_state
- stopListening
- sync
- toJSON
- trigger
- unbind
- unset
- validate
- values
- _deserialize_state
- _serialize_state

## Constructors

### constructor

- new ProxyModel(widget_manager: any, model_id: any, comm: any, attributes: any): ProxyModel

- Inherited from WidgetModel.constructor

  Overwrites Model.__constructor

  - Defined in widget.ts:71

  Constructor

  Creates a WidgetModel instance.

  ## Parameters

  widget_manager : WidgetManager instance model_id : string An ID unique to this model. comm : Comm instance (optional)

  #### Parameters

  - ##### widget_manager: any

  - ##### model_id: any

  - ##### comm: any

  - ##### attributes: any

  #### Returns ProxyModel

## Properties

### _buffered_state_diff

_buffered_state_diff: any

Inherited from WidgetModel._buffered_state_diff

- Defined in widget.ts:493

### attributes

attributes: any

Inherited from Model.attributes

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:109

### changed

changed: any[]

Inherited from Model.changed

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:110

### cid

cid: string

Inherited from Model.cid

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:111

### collection

collection: Collection<any>

Inherited from Model.collection

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:112

### comm

comm: any

Inherited from WidgetModel.comm

- Defined in widget.ts:498

### comm_live

comm_live: boolean

Inherited from WidgetModel.comm_live

- Defined in widget.ts:499

### id

id: any

Inherited from Model.id

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:120

### idAttribute

idAttribute: string

Inherited from Model.idAttribute

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:121

### model_id

model_id: string

Inherited from WidgetModel.model_id

- Defined in widget.ts:500

### msg_buffer

msg_buffer: any

Inherited from WidgetModel.msg_buffer

- Defined in widget.ts:495

### msg_buffer_callbacks

msg_buffer_callbacks: any

Inherited from WidgetModel.msg_buffer_callbacks

- Defined in widget.ts:501

### pending_msgs

pending_msgs: any

Inherited from WidgetModel.pending_msgs

- Defined in widget.ts:494

### state_change

state_change: any

Inherited from WidgetModel.state_change

- Defined in widget.ts:492

### state_lock

state_lock: any

Inherited from WidgetModel.state_lock

- Defined in widget.ts:496

### url

url: any

Inherited from ModelBase.url

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:96

### urlRoot

urlRoot: any

Inherited from Model.urlRoot

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:123

### validationError

validationError: any

Inherited from Model.validationError

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:122

### views

views: any

Inherited from WidgetModel.views

- Defined in widget.ts:497

### widget_manager

widget_manager: any

Inherited from WidgetModel.widget_manager

- Defined in widget.ts:491

### Static serializers

serializers: any = _.extend({child: {deserialize: unpack_models}}, DOMWidgetModel.serializers)

Overwrites DOMWidgetModel.serializers

- Defined in widget_box.ts:50

## Methods

### _handle_comm_closed

- _handle_comm_closed(msg: any): void

- Inherited from WidgetModel._handle_comm_closed

  - Defined in widget.ts:149

  Handle when a widget is closed.

  #### Parameters

  - ##### msg: any

  #### Returns void

### _handle_comm_msg

- _handle_comm_msg(msg: any): any

- Inherited from WidgetModel._handle_comm_msg

  - Defined in widget.ts:157

  Handle incoming comm msg.

  #### Parameters

  - ##### msg: any

  #### Returns any

### _handle_status

- _handle_status(msg: any, callbacks: any): void

- Inherited from WidgetModel._handle_status

  - Defined in widget.ts:224

  Handle status msgs.

  execution_state : ('busy', 'idle', 'starting')

  #### Parameters

  - ##### msg: any

  - ##### callbacks: any

  #### Returns void

### bind

- bind(eventName: string, callback: Function, context?: any): any

- Inherited from Events.bind

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:86

  #### Parameters

  - ##### eventName: string

  - ##### callback: Function

  - ##### Optional context: any

  #### Returns any

### callbacks

- callbacks(view?: any): any

- Inherited from WidgetModel.callbacks

  - Defined in widget.ts:248

  Create msg callbacks for a comm msg.

  #### Parameters

  - ##### Optional view: any

  #### Returns any

### change

- change(): any

- Inherited from Model.change

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:149

  #### Returns any

### changedAttributes

- changedAttributes(attributes?: any): any[]

- Inherited from Model.changedAttributes

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:150

  #### Parameters

  - ##### Optional attributes: any

  #### Returns any[]

### clear

- clear(options?: Silenceable): any

- Inherited from Model.clear

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:151

  #### Parameters

  - ##### Optional options: Silenceable

  #### Returns any

### clone

- clone(): Model

- Inherited from Model.clone

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:152

  #### Returns Model

### close

- close(comm_closed: any): void

- Inherited from WidgetModel.close

  - Defined in widget.ts:127

  Close model

  #### Parameters

  - ##### comm_closed: any

  #### Returns void

### defaults

- defaults(): any

- Overwrites DOMWidgetModel.defaults

  - Defined in widget_box.ts:42

  #### Returns any

### destroy

- destroy(options?: ModelDestroyOptions): any

- Inherited from Model.destroy

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:153

  #### Parameters

  - ##### Optional options: ModelDestroyOptions

  #### Returns any

### escape

- escape(attribute: string): string

- Inherited from Model.escape

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:154

  #### Parameters

  - ##### attribute: string

  #### Returns string

### fetch

- fetch(options?: ModelFetchOptions): JQueryXHR

- Inherited from Model.fetch

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:128

  #### Parameters

  - ##### Optional options: ModelFetchOptions

  #### Returns JQueryXHR

### get

- get(attributeName: string): any

- Inherited from Model.get

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:137

  For strongly-typed access to attributes, use the `get` method only privately in public getter properties.

  example

    get name(): string { return super.get("name"); }

  #### Parameters

  - ##### attributeName: string

  #### Returns any

### get_state

- get_state(drop_defaults: any): any

- Inherited from WidgetModel.get_state

  - Defined in widget.ts:204

  Get the serializable state of the model.

  If drop_default is thruthy, attributes that are equal to their default values are dropped.

  #### Parameters

  - ##### drop_defaults: any

  #### Returns any

### has

- has(attribute: string): boolean

- Inherited from Model.has

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:155

  #### Parameters

  - ##### attribute: string

  #### Returns boolean

### hasChanged

- hasChanged(attribute?: string): boolean

- Inherited from Model.hasChanged

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:156

  #### Parameters

  - ##### Optional attribute: string

  #### Returns boolean

### initialize

- initialize(attributes?: any, options?: any): void

- Inherited from Model.initialize

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:126

  #### Parameters

  - ##### Optional attributes: any

  - ##### Optional options: any

  #### Returns void

### invert

- invert(): any

- Inherited from Model.invert

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:172

  #### Returns any

### isNew

- isNew(): boolean

- Inherited from WidgetModel.isNew

  Overwrites Model.isNew

  - Defined in widget.ts:69

  Test to see if the model has been synced with the server.

  #### Notes

  As of backbone 1.1, backbone ignores `patch` if it thinks the model has never been pushed.

  #### Returns boolean

### isValid

- isValid(options?: any): boolean

- Inherited from Model.isValid

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:158

  #### Parameters

  - ##### Optional options: any

  #### Returns boolean

### keys

- keys(): string[]

- Inherited from Model.keys

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:169

  #### Returns string[]

### listenTo

- listenTo(object: any, events: string, callback: Function): any

- Inherited from Events.listenTo

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:90

  #### Parameters

  - ##### object: any

  - ##### events: string

  - ##### callback: Function

  #### Returns any

### listenToOnce

- listenToOnce(object: any, events: string, callback: Function): any

- Inherited from Events.listenToOnce

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:91

  #### Parameters

  - ##### object: any

  - ##### events: string

  - ##### callback: Function

  #### Returns any

### off

- off(eventName?: string, callback?: Function, context?: any): any

- Inherited from Events.off

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:84

  #### Parameters

  - ##### Optional eventName: string

  - ##### Optional callback: Function

  - ##### Optional context: any

  #### Returns any

### omit

- omit(keys: string[]): any
- omit(...keys: string[]): any

- Inherited from Model.omit

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:175

  #### Parameters

  - ##### keys: string[]

  #### Returns any

- Inherited from Model.omit

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:176

  #### Parameters

  - ##### Rest ...keys: string[]

  #### Returns any

### on

- on(eventName: string, callback?: Function, context?: any): any
- on(eventMap: EventsHash): any

- Inherited from Events.on

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:82

  #### Parameters

  - ##### eventName: string

  - ##### Optional callback: Function

  - ##### Optional context: any

  #### Returns any

- Inherited from Events.on

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:83

  #### Parameters

  - ##### eventMap: EventsHash

  #### Returns any

### on_some_change

- on_some_change(keys: any, callback: any, context: any): void

- Inherited from WidgetModel.on_some_change

  - Defined in widget.ts:425

  on_some_change(['key1', 'key2'], foo, context) differs from on('change:key1 change:key2', foo, context). If the widget attributes key1 and key2 are both modified, the second form will result in foo being called twice while the first will call foo only once.

  #### Parameters

  - ##### keys: any

  - ##### callback: any

  - ##### context: any

  #### Returns void

### once

- once(events: string, callback: Function, context?: any): any

- Inherited from Events.once

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:89

  #### Parameters

  - ##### events: string

  - ##### callback: Function

  - ##### Optional context: any

  #### Returns any

### pairs

- pairs(): any[]

- Inherited from Model.pairs

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:171

  #### Returns any[]

### parse

- parse(response: any, options?: any): any

- Inherited from ModelBase.parse

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:97

  #### Parameters

  - ##### response: any

  - ##### Optional options: any

  #### Returns any

### pick

- pick(keys: string[]): any
- pick(...keys: string[]): any

- Inherited from Model.pick

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:173

  #### Parameters

  - ##### keys: string[]

  #### Returns any

- Inherited from Model.pick

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:174

  #### Parameters

  - ##### Rest ...keys: string[]

  #### Returns any

### previous

- previous(attribute: string): any

- Inherited from Model.previous

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:159

  #### Parameters

  - ##### attribute: string

  #### Returns any

### previousAttributes

- previousAttributes(): any[]

- Inherited from Model.previousAttributes

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:160

  #### Returns any[]

### save

- save(attributes?: any, options?: ModelSaveOptions): any

- Inherited from Model.save

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:161

  #### Parameters

  - ##### Optional attributes: any

  - ##### Optional options: ModelSaveOptions

  #### Returns any

### save_changes

- save_changes(callbacks: any): void

- Inherited from WidgetModel.save_changes

  - Defined in widget.ts:411

  Push this model's state to the back-end

  This invokes a Backbone.Sync.

  #### Parameters

  - ##### callbacks: any

  #### Returns void

### send

- send(content: any, callbacks: any, buffers?: any): void

- Inherited from WidgetModel.send

  - Defined in widget.ts:116

  Send a custom msg over the comm.

  #### Parameters

  - ##### content: any

  - ##### callbacks: any

  - ##### Optional buffers: any

  #### Returns void

### send_sync_message

- send_sync_message(attrs: any, callbacks: any): void

- Inherited from WidgetModel.send_sync_message

  - Defined in widget.ts:366

  #### Parameters

  - ##### attrs: any

  - ##### callbacks: any

  #### Returns void

### set

- set(key: any, val?: any, options?: any): Model

- Inherited from WidgetModel.set

  Overwrites Model.set

  - Defined in widget.ts:266

  Set a value.

  We just call the super method, in which val and options are optional

  #### Parameters

  - ##### key: any

  - ##### Optional val: any

  - ##### Optional options: any

  #### Returns Model

### set_state

- set_state(state: any): void

- Inherited from WidgetModel.set_state

  - Defined in widget.ts:188

  Handle when a widget is updated from the backend.

  #### Parameters

  - ##### state: any

  #### Returns void

### stopListening

- stopListening(object?: any, events?: string, callback?: Function): any

- Inherited from Events.stopListening

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:92

  #### Parameters

  - ##### Optional object: any

  - ##### Optional events: string

  - ##### Optional callback: Function

  #### Returns any

### sync

- sync(method: any, model: any, options: any): any

- Inherited from WidgetModel.sync

  Overwrites ModelBase.sync

  - Defined in widget.ts:299

  Handle sync to the back-end. Called when a model.save() is called.

  Make sure a comm exists.

  ## Parameters

  method : create, update, patch, delete, read create/update always send the full attribute set patch - only send attributes listed in options.attrs, and if we are queuing up messages, combine with previous messages that have not been sent yet model : the model we are syncing will normally be the same as `this` options : dict the `attrs` key, if it exists, gives an {attr: value} dict that should be synced, otherwise, sync all attributes.

  #### Parameters

  - ##### method: any

  - ##### model: any

  - ##### options: any

  #### Returns any

### toJSON

- toJSON(options: any): string

- Inherited from WidgetModel.toJSON

  Overwrites ModelBase.toJSON

  - Defined in widget.ts:437

  Serialize the model. See the deserialization function at the top of this file and the kernel-side serializer/deserializer.

  #### Parameters

  - ##### options: any

  #### Returns string

### trigger

- trigger(eventName: string, ...args: any[]): any

- Inherited from Events.trigger

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:85

  #### Parameters

  - ##### eventName: string

  - ##### Rest ...args: any[]

  #### Returns any

### unbind

- unbind(eventName?: string, callback?: Function, context?: any): any

- Inherited from Events.unbind

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:87

  #### Parameters

  - ##### Optional eventName: string

  - ##### Optional callback: Function

  - ##### Optional context: any

  #### Returns any

### unset

- unset(attribute: string, options?: Silenceable): Model

- Inherited from Model.unset

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:162

  #### Parameters

  - ##### attribute: string

  - ##### Optional options: Silenceable

  #### Returns Model

### validate

- validate(attributes: any, options?: any): any

- Inherited from Model.validate

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:163

  #### Parameters

  - ##### attributes: any

  - ##### Optional options: any

  #### Returns any

### values

- values(): any[]

- Inherited from Model.values

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/typings/backbone/backbone-global.d.ts:170

  #### Returns any[]

### Static _deserialize_state

- _deserialize_state(state: any, manager: any): Promise<any>

- Inherited from WidgetModel._deserialize_state

  - Defined in widget.ts:446

  Returns a promise for the deserialized state. The second argument is an instance of widget manager, which is required for the deserialization of widget models.

  #### Parameters

  - ##### state: any

  - ##### manager: any

  #### Returns Promise<any>

### Static _serialize_state

- _serialize_state(state: any, manager: any): Promise<any>

- Inherited from WidgetModel._serialize_state

  - Defined in widget.ts:468

  Returns a promise for the serialized state. The second argument is an instance of widget manager.

  #### Parameters

  - ##### state: any

  - ##### manager: any

  #### Returns Promise<any>

Generated using TypeDoc